{-# Language DeriveDataTypeable #-}

module Main (main) where

import System.Console.CmdArgs.Implicit
import System.Touched

data Options = Options { call    :: String
                       , recurse :: Bool
                       , files   :: [String]
                       } deriving (Show, Data, Typeable)

options :: Options
options = Options { call    = def   &= help "The shell command to run on change"
                  , recurse = False &= help "Recurse into directories"
                  , files   = def   &= args &= typ "FILES" }

main :: IO ()
main = do
  opts <- cmdArgs options
  let fs = files opts
  let cmd = call opts
  if null fs then error "At least one file to watch must be specified."
  else if null cmd then error "You must provide a shell command to call on change."
  else onChangeAny fs (call opts)
